#include "AnalysisServiceInterface.hh"
#include "AnalysisArguments.h"

namespace SctAnalysis {
  using std::string;
  using std::list;
  using std::endl;

  AnalysisArguments::AnalysisArguments(int argc, char** argv) : 
    Arguments(argc, argv), m_strategy("NagFitStrategy"), m_options("NQR")
  {
    parse();
  }
  void AnalysisArguments::parse(){
    Arguments::parse();
    for (list<string>::iterator i=m_list.begin(); i!=m_list.end(); ++i){
      if (*i == "-options"){
	m_options=next(i);
      } else if (*i == "-strategy"){
	m_strategy=next(i);
      }
    }
    if (instanceName()=="") setInstanceName(AnalysisServiceI::AnalysisServiceInterface::instanceName);
  }
  void AnalysisArguments::printHelp(std::ostream& oss) const{
    oss << "AnalysisArguments:" << endl
	<< "  -strategy  <strategy name>     : set fit stragety to e.g. RootFitStrategy or NagFitStrategy" <<endl
	<< "  -options  <options>            : set fit options e.g. NQR" <<endl;
    Arguments::printHelp(oss);
  }

  std::string AnalysisArguments::getStrategyName() const{
    return m_strategy;
  }

  std::string AnalysisArguments::getFitOptions() const{
    return m_options;
  }
}
