#ifndef SCT_ARCHIVER_ARCHIVERARGUMENTS_H
#define SCT_ARCHIVER_ARCHIVERARGUMENTS_H
#include "SctService/Arguments.h"

namespace SctArchiving {
/** Command line arguments available for fitting service */
class ArchiverArguments : public SctService::Arguments {
 public:
  /** 
      constructor builds from command line args 
  */
  ArchiverArguments(int argc, char** argv);
  /**
     compression level (1->9) -compress
  */
  unsigned getCompressionLevel() const;
  /** 
      overload SctService::Arguments::printHelp(std::ostream)
  */
  void printHelp(std::ostream& os) const;
  /**
     overload SctService::Arguments::parse()
  */
  virtual void parse();
  /** 
      name of directory to save to: -persist
   */
  std::string getPersistentDirectory() const;
private:
  ArchiverArguments();
  unsigned m_compressionLevel;
  std::string m_persistentDir;
};
}

#endif
