#ifndef TESTLIBRARYIMPL_H
#define TESTLIBRARYIMPL_H

#include "ipc/TestLibrary.h"
#include <boost/utility.hpp>
#include <ipc/object.h>

namespace SctCalibrationController {
using namespace Ipc;
    
class TestLibraryImpl : public TestLibrary {
 public:
    typedef Sct_CalibrationController::TestRequest_ptr(*FunctionPointer)();
    static bool registerStaticFactoryMethodForTest(const std::string & name,  const FunctionPointer f);
 private:
    typedef std::map<std::string, FunctionPointer> StringFunctionPtrMap;
    static StringFunctionPtrMap & stringFunctionPtrMap() { static StringFunctionPtrMap ans; return ans; };
 public:
    // The name that is supplied to this method should be the "bare" name of the test, i.e. leave out
    // any trailing "Test".  Example:  "StrobeDelay" not "StrobeDelayTest"
    virtual Sct_CalibrationController::TestRequest_ptr getTestRequestByName(const char * name);
    virtual Sct_CalibrationController::TestLibrary::Strings* getTestNames();
    static Sct_CalibrationController::TestLibrary_ptr instance();
private:
    TestLibraryImpl();
};
    
}

#endif //TESTLIBRARYIMPL_H
