#ifndef SEQUENCEREQUEST_H
#define SEQUENCEREQUEST_H

#include "CalibrationController.hh"
#include <ipc/object.h>
#include <memory>
#include <string>
#include "boost/shared_ptr.hpp"

using std::string;
using std::auto_ptr;

namespace SctCalibrationController {
namespace Ipc {
    
class CalibrationController;
class TestRequest;

/**
  See the documentation in CalibrationController.idl for these methods.
  All may throw RequestException.  This is the nice interface
  */

/*
class SequenceRequest {
public:
    virtual ~SequenceRequest() {}
    virtual string startSequence(Sct_SctApi::SctApiIPC_ptr api) = 0;
    virtual TestRequest* getNextTest(unsigned long index) = 0;
    virtual void endSequence() = 0;    
};
*/

/**
  This is the internal implementation - to be derived from!
  */
class SequenceRequestImpl : 
  public IPCObject<POA_Sct_CalibrationController::SequenceRequest> {
protected:
  //boost::shared_ptr<SequenceRequest> m_sequenceRequest;
public:	    
    SequenceRequestImpl();
    virtual char * startSequence (/*CalibrationControllerStatus *_status, */Sct_SctApi::SctApiIPC_ptr api);
    virtual Sct_CalibrationController::TestRequest_ptr getNextTest (/*Sct_CalibrationControllerStatus *_status, */CORBA::ULong index);
    virtual void endSequence (/*CalibrationControllerStatus *_status*/);
};

/*
///
  This is the adapter for external implementations.
  These calls may fail and throw RequestExceptions
  

class SequenceRequestAdapter : public virtual SequenceRequest {
public:
    SequenceRequestAdapter(Sct_CalibrationController::SequenceRequest_ptr req);    
    
    virtual string startSequence(Sct_SctApi::SctApiIPC_ptr api);
    virtual TestRequest* getNextTest(unsigned long index);
    virtual void endSequence();
    
private:
    Sct_CalibrationController::SequenceRequest_var request;
};
*/
}
}
#endif //SEQUENCEREQUEST_H
