#include "DoubleTriggerNoiseTestResult.h"
#include "NullVariable.h"
#include "Sct/SctParameters.h"
#include "Sct/LogicErrors.h"
#include "Sct/OutOfRangeError.h"

using namespace Sct;

namespace SctData {

DoubleTriggerNoiseTestResult::DoubleTriggerNoiseTestResult() throw() : m_pedestal(nChipModule), m_peak(nChipModule){
}

DoubleTriggerNoiseTestResult::DoubleTriggerNoiseTestResult(const unsigned int runNumber, const string& moduleName) throw() 
  : TestResult(runNumber, moduleName, NullVariable::instance(), NullVariable::instance()),
    m_pedestal(nChipModule), m_peak(nChipModule) {
}

string DoubleTriggerNoiseTestResult::getClassName() const throw() {
    return "SctData::DoubleTriggerNoiseTestResult";
}

  float DoubleTriggerNoiseTestResult::getPedestalOccupancy(short unsigned ichip) const{
    return m_pedestal[ichip];
  }

  void  DoubleTriggerNoiseTestResult::setPedestalOccupancy(short unsigned ichip, float value){
    m_pedestal[ichip]=value;
  }

  float DoubleTriggerNoiseTestResult::getPeakOccupancy(short unsigned ichip) const{
    return m_peak[ichip];
  }

  void DoubleTriggerNoiseTestResult::setPeakOccupancy(short unsigned ichip, float value){
    m_peak[ichip]=value;
  }
}
