#include <ipc/object.h>
#include <ipc/core.h>

#include "Sct_SctApi/SctApi.hh"

int main(int argv, char** argc) {
  IPCCore::init(argv,argc);
  IPCPartition p("SCT");
  Sct_SctApi::SctApiIPC_var tapi = 
    p.lookup<Sct_SctApi::SctApiIPC>("Test_Server");
  if (CORBA::is_nil(tapi)) {
    std::cout << "Error getting SctApi" << std::endl;
    return -1;
  }
  std::cout << "Successfully got the Api server reference?\n";

  tapi->status();

  std::cout << "Get default Scan\n";

  Sct_SctApi::Scan_var nmask = 
    tapi->createScan();

  if (CORBA::is_nil(nmask)) {
    std::cout << "Error getting scan\n";
    return -1;
  } else {
    std::cout << "*******  Try printing scan before modification\n";
    nmask->print();
  }

  std::cout << "Set up for nmask...\n";

  nmask->setNTrigs(1000);
//   nmask->setOption(&status, Sct_SctApi_T_Scan_ScanOptions_distSlave, 1);
  nmask->configure(9, 0, 128, 1);
  nmask->getTrigger1()->singleL1A();

  std::cout << "*******  Try printing scan after modification\n";
  nmask->print();

  tapi->initialiseAll(1);

  tapi->modifyABCDVar(14, 1.0);     // Send mask bit

  std::cout << "Try doing scan\n";
  tapi->doScan(nmask);
  std::cout << "Done!\n";

  tapi->shutdownAll();

  nmask->shutdown();
  return 0;
}
