// A more advanced "example", used to develop the 
// double trigger noise test

//  SI is already defined if run from the scripting
//  menu from the SCT GUI
SI = GuiComponents.System.SystemInterface.getInstance();

api = SI.getSctApi();
cal = SI.getCalibrationController();
scanRequest = cal.getScanLibrary().defaultScan();
scan = scanRequest.getScan();

// These should be wrapped in a TestRequest in order 
// to be guaranteed to be restored afterwards 
//  (these particular variables will be reset by most scans)
sdesc = Sct.ScanDescriptors.getInstance();
api.modifyABCDVar(sdesc.valueFor("ST_COMPRESSION"), 1.0);
api.modifyABCDVar(sdesc.valueFor("ST_EDGE_DETECT"), 0.0);
api.modifyABCDVar(sdesc.valueFor("ST_SEND_MASK"), 0.0);
api.modifyABCDVar(sdesc.valueFor("ST_QTHR"), 0.9);

scan.setNTrigs(100000);
scan.setOption(Sct_SctApi.ScanPackage.ScanOptions.distSlave, 0);
scan.setOption(Sct_SctApi.ScanPackage.ScanOptions.nth, 2);

trigger = scan.getTrigger1();
trigger.doubleL1A((short)120);
trigger.setCommIncr((short)1, (short)1);

scan.configure((short)sdesc.valueFor("ST_ELAPSED"), 120, 160, 1.0);

// The second trigger
scan.setOption(Sct_SctApi.ScanPackage.ScanOptions.nth_rem, 0);
cal.doScan(scanRequest);

// The wrong trigger
scan.setOption(Sct_SctApi.ScanPackage.ScanOptions.nth_rem, 1);
cal.doScan(scanRequest);

