#!/usr/bin/perl -w
use Fcntl;
use strict;
use CGI qw(param);

#use CGI::Carp qw(fatalsToBrowser);

use lib "/userdisk/daquser/perllibs2";
use webconfig;

my @sctViews = ("Barrel 3","Barrel 4","Barrel 5","Barrel 6");



################################################################# Do not edit anything after this line


my %daqInfo = ();
my %daqMapping=();
my $daqInfoExists=0;
my @barrelCount = (0,0,0,0);
my @barrelRows = (32,40,48,56);

my %moduleOrigin=();
my $originInfoExists=0;
my $moduleMountMapIsValid=0;

print "Content-type: text/html\n\n";

getConfiguration();

my $showcurrentconfig = param("currentconfig") ? param("currentconfig") : 0;
my $index = param("index") ? param("index") : 0;

&readDaqTable();
&printBarrelFile();


sub printError {
 my ($reason) = @_;
 
   print qq!
  <html>
<head>
<title>Barrel Module Positions</title>
</head>
<body>

<h3><font color=red>Error</font></h3>
<br>
$reason
<br><br>

</body>
</html>
!;
die;
}




sub readDaqTable() {

     # config for that dataset or the current config?
     # ie moduleMounts0.txt or moduleMap0.txt, where 0=barrel3, 1-barrel4 etc

      my $lookup = ($showcurrentconfig) ? "${lookupDir}moduleMap$config{$index}{TYPE}.txt" : "${lookupDir}moduleMounts${index}.txt";
      

      if(!(-e "$lookup")) {return;}

      open(IN,$lookup) || printError("Cant open $lookup: $!");
      flock(IN,1) || printError("Cant get LOCK_SH on $lookup: $!");

      while(<IN>) {
        if(/(\d{14})=Barrel\s*(\d+),\s*Row\s*(\d+),\s*Position\s*([-\d]+)/) {
            $daqInfo{$1}="Barrel $2, Row $3, Position $4";
            $barrelCount[$2-3]++;
            my $position = $4;
            $position+=6;
            if($position>=7) {$position--;}
            my $newpos = ($position + ($3 * 12))<<4;
            my $index = $2 - 3 + $newpos;
            $daqMapping{$index} = $1;
            $daqInfoExists++;
            }
          }
      close(IN) || printError("Cant close $lookup: $!");
      }


sub printBarrelFile {

my $barrelIndex=$index;
my $rows = $barrelRows[$barrelIndex];

my $line = ($showcurrentconfig) ? " modules are in the current SctRodDaq Configuration for " : " modules have been assembled to ";

my $infoline = ($daqInfoExists>0) ? "<font color=navy><b>$barrelCount[$barrelIndex] $line $sctViews[$barrelIndex] :</b></font>" : "<font color=red><b>Sorry, the module assignment data for $sctViews[$barrelIndex] is not currently available</b></font>";

my $thisTitle = ($showcurrentconfig) ? "SctRodDaq Configuration Map" : " Module Mount Map";
print qq!
<html>
<head>
<title>Module Positions on Barrel $sctViews[$barrelIndex]</title>
<link rel=stylesheet HREF="http://www.hep.phy.cam.ac.uk/~silicon/styles/davestyles1.css" type="text/css">
</head>
<body>
<center>
<h3> $sctViews[$barrelIndex] $thisTitle</h3>
<br>
$infoline
</center>
<br>

<table border=0 cellspacing=4 cellpadding=0>


<tr>
 <td nowrap width="50" height="0"></td>
 <td nowrap width="90" height="0"></td>
 <td nowrap width="90" height="0"></td>
 <td nowrap width="90" height="0"></td>
 <td nowrap width="90" height="0"></td>
 <td nowrap width="90" height="0"></td>
 <td nowrap width="90" height="0"></td>
 <td nowrap width="10" height="0"></td>
 <td nowrap width="90" height="0"></td>
 <td nowrap width="90" height="0"></td>
 <td nowrap width="90" height="0"></td>
 <td nowrap width="90" height="0"></td>
 <td nowrap width="90" height="0"></td>
 <td nowrap width="90" height="0"></td>
</tr>

<tr><td nowrap></td><td nowrap colspan=13 align=center><b>Module Position</b></td></tr>

<tr>
<td nowrap></td>
<td nowrap align=center><b>-6</b></td>
<td nowrap align=center><b>-5</b></td>
<td nowrap align=center><b>-4</b></td>
<td nowrap align=center><b>-3</b></td>
<td nowrap align=center><b>-2</b></td>
<td nowrap align=center><b>-1</b></td>
<td nowrap></td>
<td nowrap align=center><b>1</b></td>
<td nowrap align=center><b>2</b></td>
<td nowrap align=center><b>3</b></td>
<td nowrap align=center><b>4</b></td>
<td nowrap align=center><b>5</b></td>
<td nowrap align=center><b>6</b></td>
</tr>
!;

for (my $row=0;$row<$rows; $row++) {
 print "<tr><td nowrap align=right><b>Row $row: </b></td>\n";
 for (my $pos=0;$pos<12;$pos++) {
   my $posindex = ($pos + ($row * 12))<<4;
   my $index = $barrelIndex + $posindex;
   my $content = (exists $daqMapping{$index}) ? "<a name=$daqMapping{$index}></a>$daqMapping{$index}" : "";
   print "<td nowrap bgcolor=#eeeeff align=center>$content</td>";
   if($pos==5) {print "<td></td>";}
   }
 print "</tr>\n";
 }

print qq!
</table>
</body>
</html>
!;

}
